//
//  DirectionManager.h
//  Dynamics
//
//  Created by Pierre d'Herbemont on Thu Jul 27 2001.
//		steg : steg@mac.com
//
//  This class provide a way to add a 'direction' system to Mandelbrot's Dynamics
//  note that I changed nothing in your code.
#import "MandelView.h"
#import "DirectionManager.h"
#import <Foundation/Foundation.h>
@implementation DirectionManager

- (IBAction)UP:(id)sender
{
    NSNumber	*y;
    if([aMandelView bounds].size.width>[aMandelView bounds].size.height) {	//x units>y units
        y=[NSDecimalNumber numberWithDouble:4.1];
    } else
    {
        y=[NSDecimalNumber numberWithDouble:
        4.1/([aMandelView bounds].size.height)*([aMandelView bounds].size.width)];// y = 4.1 / h * w
    }
    [aMandelView setCwy:(							// center Y =
            [aMandelView Cwy]+[y doubleValue]/[aMandelView Magnify]*0.5)];	//	center Y + y / Mag * 0.8
    [aMandelView display];
}
- (IBAction)DOWN:(id)sender
{

    NSNumber	*y;
    if([aMandelView bounds].size.width>[aMandelView bounds].size.height) {	//x units>y units
        y=[NSDecimalNumber numberWithDouble:4.1];
    } else
    {
        y=[NSDecimalNumber numberWithDouble:
        4.1/([aMandelView bounds].size.height)*([aMandelView bounds].size.width)];// y = 4.1 / h * w
    }
    [aMandelView setCwy:(							// center Y =
            [aMandelView Cwy]+[y doubleValue]/[aMandelView Magnify]*0.5*-1)];	//	center Y + y / Mag * 0.8	
    [aMandelView display];
}
- (IBAction)Left:(id)sender
{
    NSNumber	*x;
    if([aMandelView bounds].size.height>[aMandelView bounds].size.width) {	//y units>x units
        x=[NSDecimalNumber numberWithDouble:4.1];
    } else
    {
        x=[NSDecimalNumber numberWithDouble:
        4.1/([aMandelView bounds].size.width)*([aMandelView bounds].size.height)];// 4.1 / h * w
    }
    [aMandelView setCwx:							// center X =
            [aMandelView Cwx]+[x floatValue]				//  center X +( x / Mag * 0.5*-1)
                    /[aMandelView Magnify]*0.5*-1];		 
    [aMandelView display];
}
- (IBAction)Right:(id)sender
{
    NSNumber	*x;
    if([aMandelView bounds].size.height>[aMandelView bounds].size.width) {	//y units>x units
        x=[NSDecimalNumber numberWithDouble:4.1];
    } else
    {
        x=[NSDecimalNumber numberWithDouble:
        4.1/([aMandelView bounds].size.width)*([aMandelView bounds].size.height)];// 4.1 / h * w
    }
    [aMandelView setCwx:							// center X =
            [aMandelView Cwx]+[x floatValue]				//  center X +( x / Mag * 0.5 )
                    /[aMandelView Magnify]*0.5];		 
    [aMandelView display];

}
- (IBAction)zoomIn:(id)sender 
{
    double x,y,width,height;
    x = [aMandelView bounds].size.width/4;
    y = [aMandelView bounds].size.height/4;
    width = [aMandelView bounds].size.width/2;
    height = [aMandelView bounds].size.height/2;
    
    [aMandelView growRect:NSMakeRect(x,y,width,height)];
    [aMandelView setMagnify:[aMandelView Magnify]*2];			//Mag = Mag * 2
}
- (IBAction)zoomOut:(id)sender
{
    [aMandelView setMagnify:[aMandelView Magnify]/2];			//Mag = Mag / 2
    [aMandelView display];
}
- (void)setaMandelView:(id)aView
{
    aMandelView=aView;
}
- (id)aMandelView
{
    return aMandelView;
}
@end
