//
//  BookmarksHandle.m
//  Dynamics
//
//  Created by Pierre d'Herbemont on Thu Jul 26 2001.
//		steg : steg@mac.com
//
//  This 2 classes provide a way to add a 'bookmark' system like to Mandelbrot's Dynamics
//	Note that I move the Inspector in a new inspector which use panel, and bookmarks...
//	The bookmarks can be exported (.dynbm), and they are saved in a sort of preferences
//	file in ~/Library/DynamicsPrefs...
//  note that I changed nothing in your code, I only changed some link in IB for the
//	MandelView instance, for the new Inspector window.
//------------------------------------------------------------------------------------------
//		
//	This class is the data source of the listbox
#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>

@interface BookmarkItem : NSObject <NSCoding> {
    NSString 		*name;
    NSDecimalNumber	*x;
    NSDecimalNumber	*y;
    NSDecimalNumber	*magnitude;
    NSDecimalNumber	*shading;//0 : B&W, 1 : Shading, 2 : Color
    NSArray		*Color;
    NSDecimalNumber	*iterations;	
}
- (id)init;
- (void)dealloc;

- (void)setName:(NSString *)nName;
- (void)setX:(NSDecimalNumber *)nX;
- (void)setY:(NSDecimalNumber *)nY;
- (void)setMagnitude:(NSDecimalNumber *)nMagnitude;
- (void)setShading:(NSDecimalNumber *)nShading;
- (void)setIterations:(NSDecimalNumber *)nIterations;

- (NSString *)name ;
- (NSDecimalNumber *)x ;
- (NSDecimalNumber *)y ;
- (NSDecimalNumber *)magnitude ;
- (NSDecimalNumber *)shading ;
- (NSDecimalNumber *)iterations ;

/*NSCoding*/
- (id)initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;
@end
