#import "FullScreenManager.h"
#import "MandelView.h"
#import	"FullScreenWindow.h"
/* part of the coed are from the www.cocoadevcentral.com 'How to make an App full screen' Tutorial */
@implementation FullScreenManager
- (void)awakeFromNib;
{
    int windowLevel;
    
    // Get the shielding window level
    windowLevel = CGShieldingWindowLevel();

    // Get the screen rect of our main display
    screenRect = [[NSScreen mainScreen] frame];

    // Put up a new window
    if(aFullScreenWindow != nil)
        [FullScreenWindow release];
    aFullScreenWindow = [[FullScreenWindow alloc] initWithContentRect:screenRect
                                styleMask:NSBorderlessWindowMask
                                backing:NSBackingStoreBuffered
                                defer:NO screen:[NSScreen mainScreen]];
    [aFullScreenWindow setaFullScreenManager:self];
    [aFullScreenWindow setLevel:windowLevel];

    [aFullScreenWindow setBackgroundColor:[NSColor blackColor]];
    isFullScreen = NO;
}
- (void)dealloc
{
    [self goNormal:nil];
    [super dealloc];
}
- (IBAction)goFullScreen:(id)sender
{
    NSCursor *crosshairCursor = nil;
    MandelView	*myMandelView = [[MandelView alloc] initWithFrame:screenRect];

    // Capture the main display
    if (CGDisplayCapture( kCGDirectMainDisplay ) != kCGErrorSuccess) {
        NSLog( @"Couldn't capture the main display!" );
        // Note: you'll probably want to display a proper error dialog here
    }
        [[aMandelView window] discardCursorRects];

    {   
        NSImage *crosshairImage = [NSImage imageNamed:@"Cross"];
        NSSize imageSize = [crosshairImage size];
        crosshairCursor = [[NSCursor alloc] initWithImage:crosshairImage hotSpot:NSMakePoint((imageSize.width / 2.0), (imageSize.height / 2.0))];
        [crosshairCursor set];

    }
    
    [aMandelView stopMandelTE];
    
    [myMandelView setImageRep:[aMandelView imageRep]];
    [myMandelView setCwy:[aMandelView Cwy]];
    [myMandelView setCwx:[aMandelView Cwx]];
    [myMandelView setMagnify:[aMandelView Magnify]];
    [myMandelView setIterations:[aMandelView iterations]];
    [myMandelView setShading:[aMandelView shading]];
    
    [aFullScreenWindow setContentView:myMandelView];
    [aFullScreenWindow makeKeyAndOrderFront:nil];
    [aFullScreenWindow makeFirstResponder:aFullScreenWindow];
    //[FullScreenWindow makeKeyWindow];
    if([aFullScreenWindow isMainWindow])
        NSLog(@"mainWindow");
    isFullScreen = YES;
}

- (IBAction)goNormal:(id)sender
{
    [aMandelView setCwy:[[aFullScreenWindow contentView] Cwy]];
    [aMandelView setCwx:[[aFullScreenWindow contentView] Cwx]];
    [aMandelView setMagnify:[[aFullScreenWindow contentView] Magnify]];
    [aMandelView setIterations:[[aFullScreenWindow contentView] iterations]];
    [aMandelView setShading:[[aFullScreenWindow contentView] shading]];
    [aMandelView setImageRep:[[aFullScreenWindow contentView] imageRep]];
    
    [[aFullScreenWindow contentView] stopMandelTE];
    
    [aFullScreenWindow orderOut:nil];
    
    [[NSCursor arrowCursor] set];

    // Release the display(s)

    if (CGDisplayRelease( kCGDirectMainDisplay ) != kCGErrorSuccess)
        NSLog( @"Couldn't release the display(s)!" );
        	// Note: if you display an error dialog here, make sure you set
        	// its window level to the same one as the shield window level,
        	// or the user won't see anything.

    [[aMandelView window] enableCursorRects];
    [[aMandelView window] makeKeyAndOrderFront:nil];
    [aMandelView display];
    isFullScreen = NO;
}

- (IBAction)Toggle:(id)sender
{
    if(isFullScreen)
        [self goNormal:nil];
    else
        [self goFullScreen:nil];
}

@end
